/* -*- Javascript -*- */

var hgconfig = null;
var hgtree = null;

/* get event position */

var event = null;

function get_event_position (e) {
  var pos = { x: 0, y: 0 };

  /* find coordinates */
  if (e.pageX == null) {
    /* IE case */
    var d= (document.documentElement &&
            document.documentElement.scrollLeft != null) ?
      document.documentElement : document.body;
    pos.x = e.clientX + d.scrollLeft;
    pos.y = e.clientY + d.scrollTop;
  } else {
    /* all other browsers */
    pos.x = e.pageX;
    pos.y = e.pageY;
  }

  return pos;
}

/* menu functions */

var last_action = 'hide_menu';

function hide_menu () {

  /* prevent autohide */
  if (last_action == 'show_menu') {
    last_action = 'hide_menu';
    return;
  }

  /* hide and empty menu */
  var ref = document.getElementById ('menu');
  ref.style.visibility = 'hidden';
  ref.innerHTML = '';

}

function show_menu (e, name) {

    update_status ("", 0);
    if ((hgtree == null) || (hgtree.length == 0))
      return;

  /* function label name */
  function menu(name) {
    var ret;
    switch (name) {
    case 'edit': ret = 'Edit'; break;
    case 'delete': ret= 'Delete'; break;
    }
    return ret;
  }

  /* get event position */
  var pos = get_event_position (e);

  /* update menu */
  var ref = document.getElementById ('menu');
  var buffer = '<dl>\n';
  switch (name) {
  case 'edit':
  case 'delete':
    for (var i = 0; i < hgtree.length; i++) {
      buffer += '<dt onclick="javascript:do_menu_func(\'' + name +
        '\', \'' + hgtree[i].base + '\');">' + hgtree[i].name + '</dt>\n';
    }
    break;

  default:
    buffer += '<dt onclick="javascript:do_menu_func(\'edit\', \'' +
      name + '\');">' + menu('edit') + '</dt>\n';
    buffer += '<dt onclick="javascript:do_menu_func(\'delete\', \'' +
      name + '\');">' + menu('delete') + '</dt>\n';
    break;
  }
  buffer += '</dl>\n';
  ref.innerHTML = buffer;

  /* move and show menu */
  ref.style.left = pos.x + 'px';
  ref.style.top  = pos.y + 'px';
  ref.style.visibility = 'visible';

  last_action = 'show_menu';
}

/* create XML HTML Request object */

function create_xhr_object () {
  if (window.XMLHttpRequest)
    return new XMLHttpRequest ();

  if (window.ActiveXObject) {
    var names = ["Msxml2.XMLHTTP.6.0", "Msxml2.XMLHTTP.3.0",
                 "Msxml2.XMLHTTP", "Microsoft.XMLHTTP"];
    for (var i in names) {
      try{
        return new ActiveXObject (names[i]);
      }
      catch (err) {
      }
    }
    window.alert ("Our browser does not handle XMLHTTPRequest object.");
  }
  return null;
}

/* search repos in tree */

function search_repos (base) {

  for (var i = 0; i < hgtree.length; i++) {
    if (hgtree[i].base == base)
      return hgtree[i];
  }

  return null;
}

/* status function */

function update_status (message, stat, incr) {

  if (message == null) message = "";
  message = message.replace (/\n*$/, '');

  classname = 'empty';
  if (message.length > 0) {
    if (stat == -1) classname = 'server';
    else if (stat == 0) classname = 'message';
    else if (stat == 1) classname = 'warning';
    else classname = 'error';
  }

  var status = document.getElementById ("status");

  status.className = classname;

  if (!incr)
    status.innerHTML = '';
  status.innerHTML += "<p>" + message.replace (/\n/g, "</p>\n<p>") + "</p>";

}

/* list of variable names */

var var_text = ['contact', 'description', 'allow_read', 'deny_read', 'allow_push', 'deny_push', 'accesslog', 'errorlog'];
var var_checkbox = ['archive_bz2', 'archive_gz', 'archive_zip', 'hidden'];
var var_select = ['encoding', 'style'];
var var_names = var_text.concat (var_checkbox.concat (var_select));

/* list of config names */

var conf_text = ['root', 'name', 'logfile', 'authfile', 'authldaphost', 'authldaprequest'];
var conf_select = ['loglevel', 'style', 'auth'];
var conf_names = conf_text.concat (conf_select);

/* menu callbacks */

var menu_callbacks = {

  create: function () {

    return '';
  },

  delete: function (base) {

    document.getElementById ('delete_base').value = '';
    document.getElementById ('delete_name').value = '';

    if ((hgtree == null) || (hgtree.length == 0))
      return 'No Mercurial tree';

    var repos = search_repos (base);
    if (repos == null)
      return "Can't find repository " + base;

    document.getElementById ('delete_base').value = repos.base;
    document.getElementById ('delete_name').value = repos.name;

    return '';
  },

  edit: function (base) {

    for (var i in var_text)
      document.getElementById ('edit_' + var_text[i]).value = '';
    for (var i in var_checkbox)
      document.getElementById ('edit_' + var_checkbox[i]).checked = false;
    for (var i in var_select) {
      var select = document.getElementById ('edit_' + var_select[i]);
      for (var j = 0; j < select.options.length; j++)
        select.options[j].selected = false;
    }

    if ((hgtree == null) || (hgtree.length == 0))
      return 'No Mercurial tree';

    var repos = search_repos (base);
    if (repos == null)
      return "Can't find repository " + base;

    document.getElementById ('edit_base').value = repos.base;
    document.getElementById ('edit_name').value = repos.name;
    for (var i in var_text)
      document.getElementById ('edit_' + var_text[i]).value = repos[var_text[i]];
    for (var i in var_checkbox)
      document.getElementById ('edit_' + var_checkbox[i]).checked = (repos[var_checkbox[i]] == 1);
    for (var i in var_select) {
      var select = document.getElementById ('edit_' + var_select[i]);
      for (var j = 0; j < select.options.length; j++)
        if (repos[var_select[i]] === select.options[j].value)
          select.options[j].selected = true;
    }

    return '';
  },

  tree: function () {

    document.getElementById ('tree').innerHTML = '';

    if ((hgtree == null) || (hgtree.length == 0))
      return 'No Mercurial tree';

    var buffer = '<dl>\n';
    for (var i = 0; i < hgtree.length; i++)
      buffer += '<dt onclick="javascript:show_menu(event, \'' + hgtree[i].base + '\');return false;">' + hgtree[i].name + '</dt>\n';
    buffer += '</dl>\n';

    document.getElementById ('tree').innerHTML = buffer;

    return '';
  },

  config: function () {

    for (var i in conf_text)
      document.getElementById ('config_' + conf_text[i]).value = '';

    for (var i in conf_select)
      document.getElementById ('config_' + conf_select[i]).options[0].selected = true;

    if ((hgconfig == null) || (hgconfig.root.length == 0))
      return 'No Mercurial config';

    for (var i in conf_text)
      document.getElementById ('config_' + conf_text[i]).value = hgconfig[conf_text[i]];

    for (var i in conf_select) {
      var select = document.getElementById ('config_' + conf_select[i]);
      for (var j = 0; j < select.options.length; j++)
        if (hgconfig[conf_select[i]] === select.options[j].value)
          select.options[j].selected = true;
    }

    return '';
  }

};

/* menu action */

function do_menu_func (func, arg1) {

  var list_of_pages = new Array('config', 'tree', 'create', 'edit', 'delete');

  for (var i = 0; i <list_of_pages.length; i++) {

    var page = document.getElementById ('page_' + list_of_pages[i]);
    page.style.display = 'none';

  }

  var page = document.getElementById ('page_' + func);
  page.style.display = 'block';

  var message = menu_callbacks[func](arg1);

  update_status (message, (message.length > 0) ? 1 : 0);
}

/* load xml */

function load_xml (type, stat) {

  var xhr = create_xhr_object ();

  xhr.onreadystatechange = function() {
    if ((xhr.readyState == 4) && (xhr.status == 200)) {

      var msg = '';

      switch (type) {
      case 'tree':
        hgtree = new Array;
        var res = xhr.responseXML.documentElement.getElementsByTagName ("tree");

        for (var i = 0; i < res.length; i++) {
          hgtree[i] = new Object;
          hgtree[i].base = res[i].getElementsByTagName("base")[0].firstChild.nodeValue;
          hgtree[i].name = res[i].getElementsByTagName("name")[0].firstChild.nodeValue;
          for (var j in var_names) {
            try {
              hgtree[i][var_names[j]] = res[i].getElementsByTagName(var_names[j])[0].firstChild.nodeValue;
            }
            catch (err) {
              hgtree[i][var_names[j]] = '';
            }
          }
        }

        msg = "Mercurial tree loaded\n";

        break;

      case 'config':
        hgconfig = new Array;
        var res = xhr.responseXML.documentElement.getElementsByTagName ("config")[0];

        for (var i in conf_names) {
          try {
            hgconfig[conf_names[i]] = res.getElementsByTagName (conf_names[i])[0].firstChild.nodeValue;
          }
          catch (err) {
            hgconfig[conf_names[i]] = '';
          }
        }

        msg = "Mercurial config loaded\n";

        break;

      default:
        return;
      }

      if (stat)
        update_status (msg, 0, 1);

      if (document.getElementById ('page_' + type).style.display === 'block')
        var message = menu_callbacks[type]();

    }
  }

  xhr.open ("GET", "func.php?xml" + type, true);

  xhr.send ();
}

/* refresh */

function refresh () {

  update_status ('', 0);

  load_xml ('config', true);
  load_xml ('tree', true);

}

/* create parameter string */

function create_parameter_string (prefix) {

  var params = '';

  var name = document.getElementById (prefix + '_' + 'name').value;
  name = name.replace (/^ *(.*)/, '$1').replace (/(.*[^ ]) *$/, '$1');
  if (name.length > 0)
    params += '&name=' + escape(name);

  for (var i in var_text) {
    var value = document.getElementById (prefix + '_' + var_text[i]).value;
    if (value.length > 0)
      params += '&' + var_text[i] + '=' + escape(value);
  }

  for (var i in var_checkbox) {
    var value = document.getElementById (prefix + '_' + var_checkbox[i]).checked;
    params += '&' + var_checkbox[i] + '=' + ((value == true) ? 1 : 0);
  }

  for (var i in var_select) {
    var select = document.getElementById ('edit_' + var_select[i]);
    var value = select.options[select.options.selectedIndex].value;
    params += '&' + var_select[i] + '=' + value;
  }

  return params;
}

/* post action */

function post_action (action) {

  var xhr = create_xhr_object ();

  xhr.onreadystatechange = function() {
    if ((xhr.readyState == 4) && (xhr.status == 200)) {

      try {
        var message = xhr.responseXML.documentElement.getElementsByTagName ("message")[0];
        var text = message.getElementsByTagName ("text")[0].firstChild.nodeValue;
        var stat = message.getElementsByTagName ("stat")[0].firstChild.nodeValue;
        update_status (text, stat);
        if (stat == 0)
          load_xml ('config', false);
          load_xml ('tree', false);
      }
      catch (err) {
        update_status ("Can't understand server answer: " + err, -1);
      }
    }
  }

  /* get confirmation */
  var confmsg = '';
  switch (action) {
  case 'config':
    confmsg = "Do you really want to modify configuration";
    break;

  case 'create':
    var name = document.getElementById ('create_name').value;
    confmsg = "Do you really want to create repository '" + name + "'";
    break;

  case 'delete':
    var base = document.getElementById ('delete_base').value;
    var repos = search_repos (base);
    if (repos == null) {
      update_status ("Can't find repository " + base);
      return;
    }
    confmsg = "Do you really want to delete repository '" + repos.name + "'";
    break;

  case 'edit':
    var base = document.getElementById ('edit_base').value;
    var repos = search_repos (base);
    if (repos == null) {
      update_status ("Can't find repository " + base);
      return;
    }
    confmsg = "Do you really want to modify repository '" + repos.name + "'";
    break;
  }

  if (!window.confirm (confmsg))
    return;

  /* create paramter string */
  var params = 'action=' + action;

  switch (action) {
  case 'config':

    for (var i in conf_text)
      params += '&' + conf_text[i] + '=' + escape (document.getElementById ('config_' + conf_text[i]).value);

    for (var i in conf_select) {
      var res = document.getElementById ('config_' + conf_select[i]);
      params += '&' + conf_select[i] + '=' + res.options[res.options.selectedIndex].value;
    }
    break;

  case 'create':
    params += create_parameter_string ('create');
    break;

  case 'delete':
    var base = document.getElementById ('delete_base').value;
    if (base.length > 0)
      params += '&base=' + base;

  case 'edit':
    var base = document.getElementById ('edit_base').value;
    if (base.length > 0)
      params += '&base=' + base;
    params += create_parameter_string ('edit');
  }

  xhr.open ("POST", "func.php", true);

  xhr.setRequestHeader ("Content-type", "application/x-www-form-urlencoded");
  xhr.setRequestHeader ("Content-length", params.length);
  xhr.setRequestHeader ("Connection", "close");

  xhr.send (params);

}
