<?php /* -*- PHP -*- */

require ("library.php.inc");

init_hgrepos ();

function test ($tab, $res) {
  print_r ($tab);
  foreach ($tab as $var => $val) {
    echo "test '$var' => '$val'\n";
    if (!isset ($res[$var])) exit (1);
    if (is_numeric ($res[$var])) {
      if ($res[$var] != $val) exit (1);
    } else {
      if (strcmp ($res[$var], $val)) exit (1);
    }
    unset ($res[$var]);
    unset ($tab[$var]);
  }

  if ((count ($res) != 0) || (count ($tab) != 0))
    exit (1);
}

/* unitary tests */

$data = do_unit_test ("");

/* Test 1 */

echo "test 1\n";

test (analyse_resource ("
[web]
contact = Laurent Mazet
description = Mercurial HeadQuarter
allow_read = @devgroup
deny_read =
allow_push = @devgroup
deny_push =
allow_archive = gz
encoding = UTF-8
hidden = False
style = coal
accesslog = access.log
errorlog = error.log"),
      array ("contact" => "Laurent Mazet",
             "description" => "Mercurial HeadQuarter",
             "allow_read" => "@devgroup",
             "deny_read" => "",
             "allow_push" => "@devgroup",
             "deny_push" => "",
             "archive_bz2" => 0,
             "archive_gz" => 1,
             "archive_zip" => 0,
             "encoding" => "UTF-8",
             "hidden" => 0,
             "style" => "coal",
             "accesslog" => "access.log",
             "errorlog" => "error.log"));

/* Test 2 */

echo "test 2\n";

test (analyse_resource ("
[web]
contact = Laurent Mazet
description = Mercurial HeadQuarter
allow_read = *
deny_read = @admingroup
allow_push = *
deny_push = @admingroup
allow_archive = bz2 zip
encoding = ISO-8859-1
hidden = False
style = coal
[diff]
git = True"),
      array ("contact" => "Laurent Mazet",
             "description" => "Mercurial HeadQuarter",
             "allow_read" => "*",
             "deny_read" => "@admingroup",
             "allow_push" => "*",
             "deny_push" => "@admingroup",
             "archive_bz2" => 1,
             "archive_gz" => 0,
             "archive_zip" => 1,
             "encoding" => "ISO-8859-1",
             "hidden" => 0,
             "style" => "coal",
             "accesslog" => "",
             "errorlog" => "",
             "rest" => "[diff]\ngit = True\n"));

?>