<?php /* -*- PHP -*- */

require ("library.php.inc");

init_hgrepos ();

/* unitary tests */

$data = do_unit_test ("");

$hgrepos = build_hg_tree (HGREPOS);

$xml_data = create_xml_tree ($hgrepos);

/* Unitary checks */

$stack = import_xml ($xml_data);

if (count ($stack) != 1) exit (1);

if (!array_key_exists("xml", $stack)) exit (1);
if (count ($stack["xml"]) != 1) exit (1);

if (!array_key_exists("tree", $stack["xml"])) exit (1);
if (count ($stack["xml"]["tree"]) != 9) exit (1);

if (!array_key_exists("name", $stack["xml"]["tree"])) exit (1);
if (count ($stack["xml"]["tree"]["name"]) != 7) exit (1);
if (!array_key_exists("base", $stack["xml"]["tree"])) exit (1);
if (count ($stack["xml"]["tree"]["base"]) != 7) exit (1);
if (!array_key_exists("contact", $stack["xml"]["tree"])) exit (1);
if (count ($stack["xml"]["tree"]["contact"]) != 7) exit (1);
if (!array_key_exists("description", $stack["xml"]["tree"])) exit (1);
if (count ($stack["xml"]["tree"]["description"]) != 7) exit (1);
if (!array_key_exists("style", $stack["xml"]["tree"])) exit (1);
if (count ($stack["xml"]["tree"]["style"]) != 1) exit (1);
if (!array_key_exists("allow_read", $stack["xml"]["tree"])) exit (1);
if (count ($stack["xml"]["tree"]["allow_read"]) != 7) exit (1);
if (!array_key_exists("allow_push", $stack["xml"]["tree"])) exit (1);
if (count ($stack["xml"]["tree"]["allow_push"]) != 7) exit (1);
if (!array_key_exists("deny_read", $stack["xml"]["tree"])) exit (1);
if (count ($stack["xml"]["tree"]["deny_read"]) != 7) exit (1);
if (!array_key_exists("deny_push", $stack["xml"]["tree"])) exit (1);
if (count ($stack["xml"]["tree"]["deny_push"]) != 7) exit (1);

print ("stack:\n");
print_r ($stack);

$orig = array ("name" => array ("a", "c", "c/a", "b", "d/a", "d/a/a", "d/b"),
               "base" => array ("_a", "_c", "_c_a", "_b", "_d_a", "_d_a_a", "_d_b"),
               "contact" => array ("Laurent Mazet", null, null, null, null, null, null),
               "description" => array ("Mercurial Headquarters", null, null, null, null, null, null),
               "style" => array (0 => "gitweb"),
               "allow_read" => array (null, null, null, null, null, null, null),
               "deny_read" => array (null, null, null, null, null, null, null),
               "allow_push" => array (null, null, null, null, null, null, null),
               "deny_push" => array (null, null, null, null, null, null, null));

for ($i = 0; $i < 7; $i++) {
    echo "repos: $i\n";
    foreach (array ("name", "base", "contact", "description", "style", "allow_read", "allow_push", "deny_read", "deny_push") as $key) {
        if ((!isset ($orig[$key][$i])) && (!isset($stack["xml"]["tree"][$key][$i])))
            continue;
        echo " key: $key\n";
        if (strcmp ($stack["xml"]["tree"][$key][$i], $orig[$key][$i]) != 0) exit (1);
    }
}

exit (0);
?>
