<?php /* -*- PHP -*- */

@passthru ("rm config.inc.php");

require ("library.php.inc");

init_hgrepos ();

_file_write ("config.inc.php", "<?php /* -*- PHP -*- */
/* Mercurial repository root */
define ('HGREPOS', 'tmp/hg');
/* Log file name */
define ('LOGFILE', 'tmp/logging.log');
/* Log level */
define ('LOGLEVEL', 3);
?>");

_file_write (HGREPOS . "/hgweb.cgi", "#!/usr/bin/env python
config = 'hgweb.config'
from mercurial import demandimport; demandimport.enable()
from mercurial.hgweb import hgweb, wsgicgi
application = hgweb(config)
wsgicgi.launch(application)
");

_file_write (HGREPOS . "/hgweb.config", "[collections]
tmp/hg = tmp/hg

[web]
style = gitweb
push_ssl = false
baseurl = /hg
");

_file_write (HGREPOS . "/.htaccess", "Order allow,deny
Allow from all

Options ExecCGI FollowSymLinks
AddHandler cgi-script .cgi

RewriteEngine On
RewriteBase /hg
RewriteRule ^$ hgweb.cgi [L]
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule (.*) hgweb.cgi/$1 [QSA,L]

AuthType Basic
AuthName \"Mercurial repositories\"
AuthBasicProvider file
AuthUserFile tmp/password
Require valid-user
");

/* unitary tests */

$_POST = array ("action" => "config", "root" => HGREPOS, "name" => "hg", "logfile" => LOGFILE, "loglevel" => LOGLEVEL, "style" => "gitweb", "auth" => "file", "authfile" => "tmp/password");

$data = do_unit_test ("<xml><message><text><![CDATA[Nothing to update for configuration]]></text><stat>1</stat></message></xml>");

/* Unitary checks */

passthru ("rm config.inc.php");

exit (0);
?>