<?php /* -*- PHP -*- */

@passthru ("rm config.inc.php");
@passthru ("rm -rf tmp/hg2");

require ("library.php.inc");

init_hgrepos ();


_file_write ("config.inc.php", "<?php /* -*- PHP -*- */
/* Mercurial repository root */
define ('HGREPOS', 'tmp/hg');
/* Log file name */
define ('LOGFILE', 'tmp/logging.log');
/* Log level */
define ('LOGLEVEL', 3);
?>");

_file_write (HGREPOS . "/hgweb.cgi", "#!/usr/bin/env python
config = 'hgweb.config'
from mercurial import demandimport; demandimport.enable()
from mercurial.hgweb import hgweb, wsgicgi
application = hgweb(config)
wsgicgi.launch(application)
");

_file_write (HGREPOS . "/hgweb.config", "[collections]
tmp/hg = tmp/hg

[web]
style = gitweb
push_ssl = false
baseurl = /hg
");

_file_write (HGREPOS . "/.htaccess", "Order allow,deny
Allow from all

Options ExecCGI FollowSymLinks
AddHandler cgi-script .cgi

RewriteEngine On
RewriteBase /hg
RewriteRule ^$ hgweb.cgi [L]
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule (.*) hgweb.cgi/$1 [QSA,L]

AuthType Basic
AuthName \"Mercurial repositories\"
AuthBasicProvider file
AuthUserFile tmp/password
Require valid-user
");

/* unitary tests */

$_POST = array ("action" => "config", "root" => "tmp/hg2", "name" => "hg", "logfile" => LOGFILE, "loglevel" => LOGLEVEL, "style" => "gitweb", "auth" => "file", "authfile" => "tmp/password", "authldaphost" => "ldap.softndesign.org", "authldaprequest" => "ou=People,dc=softndesign,dc=org");

$data = do_unit_test ("<xml><message><text><![CDATA[Configuration updated\nCreate root repository 'tmp/hg2'\nAccess file written\nMercurial web server exec written\nMercurial web server config written]]></text><stat>0</stat></message></xml>",
                      array ("tmp/hg2/hgweb.cgi" => "1375b569db158c7f1cc407545d225c88",
                             "tmp/hg2/hgweb.config" => "2e3af6a4710caa436a24d7a8a5f5bdc3",
                             "tmp/hg2/.htaccess" => "53f09cdeb088577dbef89a29574ab645"),
                      array ("config.inc.php" => "5dec4fa2bea989df3a770f48a9df673d"));

/* Unitary checks */

passthru ("rm config.inc.php");
passthru ("rm -rf tmp/hg2");

exit (0);
?>